diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/olsr/model/olsr-routing-protocol.cc ns-3.39/src/olsr/model/olsr-routing-protocol.cc
--- ns-3.38/src/olsr/model/olsr-routing-protocol.cc	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/olsr/model/olsr-routing-protocol.cc	2023-07-05 14:23:48.069428200 -0700
@@ -22,7 +22,7 @@
 ///
 /// \brief Implementation of OLSR agent and related classes.
 ///
-/// This is the main file of this software because %OLSR's behaviour is
+/// This is the main file of this software because OLSR's behaviour is
 /// implemented here.
 ///
 
@@ -34,6 +34,8 @@
 
 #include "olsr-routing-protocol.h"
 
+#include "olsr-repositories.h"
+
 #include "ns3/boolean.h"
 #include "ns3/enum.h"
 #include "ns3/inet-socket-address.h"
@@ -51,6 +53,7 @@
 #include "ns3/uinteger.h"
 
 #include <iomanip>
+#include <iostream>
 
 /********** Useful macros **********/
 
@@ -84,39 +87,6 @@
 /// HNA holding time.
 #define OLSR_HNA_HOLD_TIME Time(3 * m_hnaInterval)
 
-/********** Link types **********/
-
-/// Unspecified link type.
-#define OLSR_UNSPEC_LINK 0
-/// Asymmetric link type.
-#define OLSR_ASYM_LINK 1
-/// Symmetric link type.
-#define OLSR_SYM_LINK 2
-/// Lost link type.
-#define OLSR_LOST_LINK 3
-
-/********** Neighbor types **********/
-
-/// Not neighbor type.
-#define OLSR_NOT_NEIGH 0
-/// Symmetric neighbor type.
-#define OLSR_SYM_NEIGH 1
-/// Asymmetric neighbor type.
-#define OLSR_MPR_NEIGH 2
-
-/********** Willingness **********/
-
-/// Willingness for forwarding packets from other nodes: never.
-#define OLSR_WILL_NEVER 0
-/// Willingness for forwarding packets from other nodes: low.
-#define OLSR_WILL_LOW 1
-/// Willingness for forwarding packets from other nodes: medium.
-#define OLSR_WILL_DEFAULT 3
-/// Willingness for forwarding packets from other nodes: high.
-#define OLSR_WILL_HIGH 6
-/// Willingness for forwarding packets from other nodes: always.
-#define OLSR_WILL_ALWAYS 7
-
 /********** Miscellaneous constants **********/
 
 /// Maximum allowed jitter.
@@ -143,6 +113,81 @@
 namespace olsr
 {
 
+/**
+ * \ingroup olsr
+ *
+ * OLSR link types.
+ * See \RFC{3626} section 18.5.
+ */
+enum class LinkType : uint8_t
+{
+    UNSPEC_LINK = 0, //!< Unspecified link type
+    ASYM_LINK = 1,   //!< Asymmetric link type
+    SYM_LINK = 2,    //!< Symmetric link type
+    LOST_LINK = 3,   //!< Lost link type
+};
+
+/**
+ * Stream insertion operator for OLSR link type.
+ *
+ * \param os Output stream.
+ * \param linkType OLSR link type.
+ * \return A reference to the output stream.
+ */
+inline std::ostream&
+operator<<(std::ostream& os, LinkType linkType)
+{
+    switch (linkType)
+    {
+    case LinkType::UNSPEC_LINK:
+        return (os << "UNSPEC_LINK");
+    case LinkType::ASYM_LINK:
+        return (os << "ASYM_LINK");
+    case LinkType::SYM_LINK:
+        return (os << "SYM_LINK");
+    case LinkType::LOST_LINK:
+        return (os << "LOST_LINK");
+    default:
+        return (os << "Unknown link type");
+    }
+}
+
+/**
+ * \ingroup olsr
+ *
+ * OLSR neighbor types.
+ * See \RFC{3626} section 18.6.
+ */
+enum class NeighborType : uint8_t
+{
+    NOT_NEIGH = 0, //!< Not neighbor type
+    SYM_NEIGH = 1, //!< Symmetric neighbor type
+    MPR_NEIGH = 2, //!< Asymmetric neighbor type
+};
+
+/**
+ * Stream insertion operator for OLSR link type.
+ *
+ * \param os Output stream.
+ * \param neighborType OLSR neighbor type.
+ * \return A reference to the output stream.
+ */
+inline std::ostream&
+operator<<(std::ostream& os, NeighborType neighborType)
+{
+    switch (neighborType)
+    {
+    case NeighborType::NOT_NEIGH:
+        return (os << "NOT_NEIGH");
+    case NeighborType::SYM_NEIGH:
+        return (os << "SYM_NEIGH");
+    case NeighborType::MPR_NEIGH:
+        return (os << "MPR_NEIGH");
+    default:
+        return (os << "Unknown neighbor type");
+    }
+}
+
 /********** OLSR class **********/
 
 NS_OBJECT_ENSURE_REGISTERED(RoutingProtocol);
@@ -180,17 +225,17 @@
                           MakeTimeChecker())
             .AddAttribute("Willingness",
                           "Willingness of a node to carry and forward traffic for other nodes.",
-                          EnumValue(OLSR_WILL_DEFAULT),
+                          EnumValue(Willingness::DEFAULT),
                           MakeEnumAccessor(&RoutingProtocol::m_willingness),
-                          MakeEnumChecker(OLSR_WILL_NEVER,
+                          MakeEnumChecker(Willingness::NEVER,
                                           "never",
-                                          OLSR_WILL_LOW,
+                                          Willingness::LOW,
                                           "low",
-                                          OLSR_WILL_DEFAULT,
+                                          Willingness::DEFAULT,
                                           "default",
-                                          OLSR_WILL_HIGH,
+                                          Willingness::HIGH,
                                           "high",
-                                          OLSR_WILL_ALWAYS,
+                                          Willingness::ALWAYS,
                                           "always"))
             .AddTraceSource("Rx",
                             "Receive OLSR packet.",
@@ -696,7 +741,7 @@
 
     // N2 is the set of 2-hop neighbors reachable from "the interface
     // I", excluding:
-    // (i)   the nodes only reachable by members of N with willingness WILL_NEVER
+    // (i)   the nodes only reachable by members of N with willingness Willingness::NEVER
     // (ii)  the node performing the computation
     // (iii) all the symmetric neighbors: the nodes for which there exists a symmetric
     //       link to this node on some interface.
@@ -713,22 +758,14 @@
         }
 
         //  excluding:
-        // (i)   the nodes only reachable by members of N with willingness WILL_NEVER
+        // (i)   the nodes only reachable by members of N with willingness Willingness::NEVER
         bool ok = false;
         for (NeighborSet::const_iterator neigh = N.begin(); neigh != N.end(); neigh++)
         {
             if (neigh->neighborMainAddr == twoHopNeigh->neighborMainAddr)
             {
-                if (neigh->willingness == OLSR_WILL_NEVER)
-                {
-                    ok = false;
-                    break;
-                }
-                else
-                {
-                    ok = true;
-                    break;
-                }
+                ok = (neigh->willingness != Willingness::NEVER);
+                break;
             }
         }
         if (!ok)
@@ -774,10 +811,10 @@
 #endif // NS3_LOG_ENABLE
 
     // 1. Start with an MPR set made of all members of N with
-    // N_willingness equal to WILL_ALWAYS
+    // N_willingness equal to Willingness::ALWAYS
     for (NeighborSet::const_iterator neighbor = N.begin(); neighbor != N.end(); neighbor++)
     {
-        if (neighbor->willingness == OLSR_WILL_ALWAYS)
+        if (neighbor->willingness == Willingness::ALWAYS)
         {
             mprSet.insert(neighbor->neighborMainAddr);
             // (not in RFC but I think is needed: remove the 2-hop
@@ -1058,7 +1095,7 @@
     //  neighbor node or the node itself, and such that there exist at
     //  least one entry in the 2-hop neighbor set where
     //  N_neighbor_main_addr correspond to a neighbor node with
-    //  willingness different of WILL_NEVER,
+    //  willingness different of Willingness::NEVER,
     const TwoHopNeighborSet& twoHopNeighbors = m_state.GetTwoHopNeighbors();
     for (TwoHopNeighborSet::const_iterator it = twoHopNeighbors.begin();
          it != twoHopNeighbors.end();
@@ -1083,14 +1120,14 @@
 
         // ...and such that there exist at least one entry in the 2-hop
         // neighbor set where N_neighbor_main_addr correspond to a
-        // neighbor node with willingness different of WILL_NEVER...
+        // neighbor node with willingness different of Willingness::NEVER...
         bool nb2hopOk = false;
         for (NeighborSet::const_iterator neighbor = neighborSet.begin();
              neighbor != neighborSet.end();
              neighbor++)
         {
             if (neighbor->neighborMainAddr == nb2hop_tuple.neighborMainAddr &&
-                neighbor->willingness != OLSR_WILL_NEVER)
+                neighbor->willingness != Willingness::NEVER)
             {
                 nb2hopOk = true;
                 break;
@@ -1746,26 +1783,26 @@
             continue;
         }
 
-        uint8_t link_type;
-        uint8_t nb_type = 0xff;
+        LinkType linkType;
+        NeighborType neighborType;
 
         // Establishes link type
         if (link_tuple->symTime >= now)
         {
-            link_type = OLSR_SYM_LINK;
+            linkType = LinkType::SYM_LINK;
         }
         else if (link_tuple->asymTime >= now)
         {
-            link_type = OLSR_ASYM_LINK;
+            linkType = LinkType::ASYM_LINK;
         }
         else
         {
-            link_type = OLSR_LOST_LINK;
+            linkType = LinkType::LOST_LINK;
         }
         // Establishes neighbor type.
         if (m_state.FindMprAddress(GetMainAddress(link_tuple->neighborIfaceAddr)))
         {
-            nb_type = OLSR_MPR_NEIGH;
+            neighborType = NeighborType::MPR_NEIGH;
             NS_LOG_DEBUG("I consider neighbor " << GetMainAddress(link_tuple->neighborIfaceAddr)
                                                 << " to be MPR_NEIGH.");
         }
@@ -1783,11 +1820,11 @@
                         NS_LOG_DEBUG("I consider neighbor "
                                      << GetMainAddress(link_tuple->neighborIfaceAddr)
                                      << " to be SYM_NEIGH.");
-                        nb_type = OLSR_SYM_NEIGH;
+                        neighborType = NeighborType::SYM_NEIGH;
                     }
                     else if (nb_tuple->status == NeighborTuple::STATUS_NOT_SYM)
                     {
-                        nb_type = OLSR_NOT_NEIGH;
+                        neighborType = NeighborType::NOT_NEIGH;
                         NS_LOG_DEBUG("I consider neighbor "
                                      << GetMainAddress(link_tuple->neighborIfaceAddr)
                                      << " to be NOT_NEIGH.");
@@ -1809,7 +1846,8 @@
         }
 
         olsr::MessageHeader::Hello::LinkMessage linkMessage;
-        linkMessage.linkCode = (link_type & 0x03) | ((nb_type << 2) & 0x0f);
+        linkMessage.linkCode = (static_cast<uint8_t>(linkType) & 0x03) |
+                               ((static_cast<uint8_t>(neighborType) << 2) & 0x0f);
         linkMessage.neighborInterfaceAddresses.push_back(link_tuple->neighborIfaceAddr);
 
         std::vector<Ipv4Address> interfaces =
@@ -2055,53 +2093,16 @@
          linkMessage != hello.linkMessages.end();
          linkMessage++)
     {
-        int lt = linkMessage->linkCode & 0x03;        // Link Type
-        int nt = (linkMessage->linkCode >> 2) & 0x03; // Neighbor Type
-
-#ifdef NS3_LOG_ENABLE
-        const char* linkTypeName;
-        switch (lt)
-        {
-        case OLSR_UNSPEC_LINK:
-            linkTypeName = "UNSPEC_LINK";
-            break;
-        case OLSR_ASYM_LINK:
-            linkTypeName = "ASYM_LINK";
-            break;
-        case OLSR_SYM_LINK:
-            linkTypeName = "SYM_LINK";
-            break;
-        case OLSR_LOST_LINK:
-            linkTypeName = "LOST_LINK";
-            break;
-        default:
-            linkTypeName = "(invalid value!)";
-        }
-
-        const char* neighborTypeName;
-        switch (nt)
-        {
-        case OLSR_NOT_NEIGH:
-            neighborTypeName = "NOT_NEIGH";
-            break;
-        case OLSR_SYM_NEIGH:
-            neighborTypeName = "SYM_NEIGH";
-            break;
-        case OLSR_MPR_NEIGH:
-            neighborTypeName = "MPR_NEIGH";
-            break;
-        default:
-            neighborTypeName = "(invalid value!)";
-        }
+        LinkType linkType = LinkType(linkMessage->linkCode & 0x03);
+        NeighborType neighborType = NeighborType((linkMessage->linkCode >> 2) & 0x03);
 
         NS_LOG_DEBUG("Looking at HELLO link messages with Link Type "
-                     << lt << " (" << linkTypeName << ") and Neighbor Type " << nt << " ("
-                     << neighborTypeName << ")");
-#endif // NS3_LOG_ENABLE
+                     << linkType << " and Neighbor Type " << neighborType);
 
         // We must not process invalid advertised links
-        if ((lt == OLSR_SYM_LINK && nt == OLSR_NOT_NEIGH) ||
-            (nt != OLSR_SYM_NEIGH && nt != OLSR_MPR_NEIGH && nt != OLSR_NOT_NEIGH))
+        if ((linkType == LinkType::SYM_LINK && neighborType == NeighborType::NOT_NEIGH) ||
+            (neighborType != NeighborType::SYM_NEIGH && neighborType != NeighborType::MPR_NEIGH &&
+             neighborType != NeighborType::NOT_NEIGH))
         {
             NS_LOG_LOGIC("HELLO link code is invalid => IGNORING");
             continue;
@@ -2115,13 +2116,13 @@
             NS_LOG_DEBUG("   -> Neighbor: " << *neighIfaceAddr);
             if (*neighIfaceAddr == receiverIface)
             {
-                if (lt == OLSR_LOST_LINK)
+                if (linkType == LinkType::LOST_LINK)
                 {
                     NS_LOG_LOGIC("link is LOST => expiring it");
                     link_tuple->symTime = now - Seconds(1);
                     updated = true;
                 }
-                else if (lt == OLSR_SYM_LINK || lt == OLSR_ASYM_LINK)
+                else if (linkType == LinkType::SYM_LINK || linkType == LinkType::ASYM_LINK)
                 {
                     NS_LOG_DEBUG(*link_tuple << ": link is SYM or ASYM => should become SYM now"
                                                 " (symTime being increased to "
@@ -2211,14 +2212,9 @@
              linkMessage != hello.linkMessages.end();
              linkMessage++)
         {
-            int neighborType = (linkMessage->linkCode >> 2) & 0x3;
-#ifdef NS3_LOG_ENABLE
-            const char* neighborTypeNames[3] = {"NOT_NEIGH", "SYM_NEIGH", "MPR_NEIGH"};
-            const char* neighborTypeName =
-                ((neighborType < 3) ? neighborTypeNames[neighborType] : "(invalid value)");
-            NS_LOG_DEBUG("Looking at Link Message from HELLO message: neighborType="
-                         << neighborType << " (" << neighborTypeName << ")");
-#endif // NS3_LOG_ENABLE
+            NeighborType neighborType = NeighborType((linkMessage->linkCode >> 2) & 0x3);
+            NS_LOG_DEBUG(
+                "Looking at Link Message from HELLO message: neighborType=" << neighborType);
 
             for (std::vector<Ipv4Address>::const_iterator nb2hop_addr_iter =
                      linkMessage->neighborInterfaceAddresses.begin();
@@ -2228,7 +2224,8 @@
                 Ipv4Address nb2hop_addr = GetMainAddress(*nb2hop_addr_iter);
                 NS_LOG_DEBUG("Looking at 2-hop neighbor address from HELLO message: "
                              << *nb2hop_addr_iter << " (main address is " << nb2hop_addr << ")");
-                if (neighborType == OLSR_SYM_NEIGH || neighborType == OLSR_MPR_NEIGH)
+                if (neighborType == NeighborType::SYM_NEIGH ||
+                    neighborType == NeighborType::MPR_NEIGH)
                 {
                     // If the main address of the 2-hop neighbor address == main address
                     // of the receiving node, silently discard the 2-hop
@@ -2263,7 +2260,7 @@
                         nb2hop_tuple->expirationTime = now + msg.GetVTime();
                     }
                 }
-                else if (neighborType == OLSR_NOT_NEIGH)
+                else if (neighborType == NeighborType::NOT_NEIGH)
                 {
                     // For each 2-hop node listed in the HELLO message
                     // with Neighbor Type equal to NOT_NEIGH all 2-hop
@@ -2300,8 +2297,8 @@
          linkMessage != hello.linkMessages.end();
          linkMessage++)
     {
-        int nt = linkMessage->linkCode >> 2;
-        if (nt == OLSR_MPR_NEIGH)
+        NeighborType neighborType = NeighborType(linkMessage->linkCode >> 2);
+        if (neighborType == NeighborType::MPR_NEIGH)
         {
             NS_LOG_DEBUG("Processing a link message with neighbor type MPR_NEIGH");
 
@@ -2386,7 +2383,7 @@
 {
     NS_LOG_DEBUG(Simulator::Now().As(Time::S) << ": OLSR Node " << m_mainAddress << " LinkTuple "
                                               << tuple.neighborIfaceAddr << " -> neighbor loss.");
-    LinkTupleUpdated(tuple, OLSR_WILL_DEFAULT);
+    LinkTupleUpdated(tuple, Willingness::DEFAULT);
     m_state.EraseTwoHopNeighborTuples(GetMainAddress(tuple.neighborIfaceAddr));
     m_state.EraseMprSelectorTuples(GetMainAddress(tuple.neighborIfaceAddr));
 
@@ -2417,7 +2414,7 @@
 }
 
 void
-RoutingProtocol::LinkTupleAdded(const LinkTuple& tuple, uint8_t willingness)
+RoutingProtocol::LinkTupleAdded(const LinkTuple& tuple, Willingness willingness)
 {
     // Creates associated neighbor tuple
     NeighborTuple nb_tuple;
@@ -2447,7 +2444,7 @@
 }
 
 void
-RoutingProtocol::LinkTupleUpdated(const LinkTuple& tuple, uint8_t willingness)
+RoutingProtocol::LinkTupleUpdated(const LinkTuple& tuple, Willingness willingness)
 {
     // Each time a link tuple changes, the associated neighbor tuple must be recomputed
 
@@ -3005,10 +3002,10 @@
 RoutingProtocol::RouteInput(Ptr<const Packet> p,
                             const Ipv4Header& header,
                             Ptr<const NetDevice> idev,
-                            UnicastForwardCallback ucb,
-                            MulticastForwardCallback mcb,
-                            LocalDeliverCallback lcb,
-                            ErrorCallback ecb)
+                            const UnicastForwardCallback& ucb,
+                            const MulticastForwardCallback& mcb,
+                            const LocalDeliverCallback& lcb,
+                            const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(this << " " << m_ipv4->GetObject<Node>()->GetId() << " "
                          << header.GetDestination());
@@ -3017,7 +3014,7 @@
     Ipv4Address origin = header.GetSource();
 
     // Consume self-originated packets
-    if (IsMyOwnAddress(origin) == true)
+    if (IsMyOwnAddress(origin))
     {
         return true;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/olsr/model/olsr-routing-protocol.h ns-3.39/src/olsr/model/olsr-routing-protocol.h
--- ns-3.38/src/olsr/model/olsr-routing-protocol.h	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/olsr/model/olsr-routing-protocol.h	2023-07-05 14:23:48.069428200 -0700
@@ -56,7 +56,7 @@
 /// functional description, please refer to the ns-3 manual.
 
 /// \ingroup olsr
-/// An %OLSR's routing table entry.
+/// An OLSR's routing table entry.
 struct RoutingTableEntry
 {
     Ipv4Address destAddr; //!< Address of the destination node.
@@ -225,12 +225,12 @@
 
     /**
      * \brief Associates the specified Ipv4StaticRouting routing table
-     *         to the OLSR routing protocol. Entries from this associated
-     *         routing table that use non-olsr outgoing interfaces are added
-     *         to the list of local HNA associations so that they are included
-     *         in HNA messages sent by the node.
-     *         If this method is called more than once, entries from the old
-     *         association are deleted before entries from the new one are added.
+     *        to the OLSR routing protocol. Entries from this associated
+     *        routing table that use non-olsr outgoing interfaces are added
+     *        to the list of local HNA associations so that they are included
+     *        in HNA messages sent by the node.
+     *        If this method is called more than once, entries from the old
+     *        association are deleted before entries from the new one are added.
      * \param routingTable the Ipv4StaticRouting routing table to be associated.
      */
     void SetRoutingTableAssociation(Ptr<Ipv4StaticRouting> routingTable);
@@ -256,11 +256,11 @@
     uint16_t m_messageSequenceNumber; //!< Messages sequence number counter.
     uint16_t m_ansn;                  //!< Advertised Neighbor Set sequence number.
 
-    Time m_helloInterval;  //!< HELLO messages' emission interval.
-    Time m_tcInterval;     //!< TC messages' emission interval.
-    Time m_midInterval;    //!< MID messages' emission interval.
-    Time m_hnaInterval;    //!< HNA messages' emission interval.
-    uint8_t m_willingness; //!<  Willingness for forwarding packets on behalf of other nodes.
+    Time m_helloInterval;      //!< HELLO messages' emission interval.
+    Time m_tcInterval;         //!< TC messages' emission interval.
+    Time m_midInterval;        //!< MID messages' emission interval.
+    Time m_hnaInterval;        //!< HNA messages' emission interval.
+    Willingness m_willingness; //!< Willingness for forwarding packets on behalf of other nodes.
 
     OlsrState m_state; //!< Internal state with all needed data structs.
     Ptr<Ipv4> m_ipv4;  //!< IPv4 object the routing is linked to.
@@ -350,10 +350,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv4Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
     void SetIpv4(Ptr<Ipv4> ipv4) override;
 
     void PrintRoutingTable(Ptr<OutputStreamWrapper> stream,
@@ -391,7 +391,7 @@
     void RecvOlsr(Ptr<Socket> socket);
 
     /**
-     * \brief Computates MPR set of a node following \RFC{3626} hints.
+     * \brief Computes MPR set of a node following \RFC{3626} hints.
      */
     void MprComputation();
 
@@ -547,7 +547,7 @@
                         const Ipv4Address& senderAddress);
 
     /**
-     * \brief Enques an %OLSR message which will be sent with a delay of (0, delay].
+     * \brief Enqueues an %OLSR message which will be sent with a delay of (0, delay].
      *
      * This buffering system is used in order to piggyback several %OLSR messages in
      * a same %OLSR packet.
@@ -611,10 +611,10 @@
 
     /**
      * Adds a link tuple.
-     * \param tuple Thetuple to be added.
+     * \param tuple The tuple to be added.
      * \param willingness The tuple willingness.
      */
-    void LinkTupleAdded(const LinkTuple& tuple, uint8_t willingness);
+    void LinkTupleAdded(const LinkTuple& tuple, Willingness willingness);
 
     /**
      * \brief Removes a link tuple from the Link Set.
@@ -630,7 +630,7 @@
      * \param tuple The link tuple which has been updated.
      * \param willingness The tuple willingness.
      */
-    void LinkTupleUpdated(const LinkTuple& tuple, uint8_t willingness);
+    void LinkTupleUpdated(const LinkTuple& tuple, Willingness willingness);
 
     /**
      * \brief Adds a neighbor tuple to the Neighbor Set.
@@ -832,7 +832,7 @@
     /// Tx packet trace.
     TracedCallback<const PacketHeader&, const MessageList&> m_txPacketTrace;
 
-    /// Routing table chanes challback
+    /// Routing table changes callback
     TracedCallback<uint32_t> m_routingTableChanged;
 
     /// Provides uniform random variables.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/olsr/model/olsr-state.cc ns-3.39/src/olsr/model/olsr-state.cc
--- ns-3.38/src/olsr/model/olsr-state.cc	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/olsr/model/olsr-state.cc	2023-07-05 14:23:48.069428200 -0700
@@ -132,7 +132,7 @@
 }
 
 NeighborTuple*
-OlsrState::FindNeighborTuple(const Ipv4Address& mainAddr, uint8_t willingness)
+OlsrState::FindNeighborTuple(const Ipv4Address& mainAddr, Willingness willingness)
 {
     for (NeighborSet::iterator it = m_neighborSet.begin(); it != m_neighborSet.end(); it++)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/olsr/model/olsr-state.h ns-3.39/src/olsr/model/olsr-state.h
--- ns-3.38/src/olsr/model/olsr-state.h	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/olsr/model/olsr-state.h	2023-07-05 14:23:48.069428200 -0700
@@ -137,7 +137,7 @@
      * \param willingness The neighbor willingness.
      * \returns The neighbor tuple, if found. Else it returns a null pointer.
      */
-    NeighborTuple* FindNeighborTuple(const Ipv4Address& mainAddr, uint8_t willingness);
+    NeighborTuple* FindNeighborTuple(const Ipv4Address& mainAddr, Willingness willingness);
 
     /**
      * Erases a neighbor tuple.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/olsr/test/examples-to-run.py ns-3.39/src/olsr/test/examples-to-run.py
--- ns-3.38/src/olsr/test/examples-to-run.py	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/olsr/test/examples-to-run.py	2023-07-05 14:23:48.069428200 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/olsr/test/olsr-header-test-suite.cc ns-3.39/src/olsr/test/olsr-header-test-suite.cc
--- ns-3.38/src/olsr/test/olsr-header-test-suite.cc	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/olsr/test/olsr-header-test-suite.cc	2023-07-05 14:23:48.069428200 -0700
@@ -18,6 +18,7 @@
  */
 
 #include "ns3/olsr-header.h"
+#include "ns3/olsr-repositories.h"
 #include "ns3/packet.h"
 #include "ns3/test.h"
 
@@ -191,7 +192,7 @@
     olsr::MessageHeader::Hello& helloIn = msgIn.GetHello();
 
     helloIn.SetHTime(Seconds(7));
-    helloIn.willingness = 66;
+    helloIn.willingness = olsr::Willingness::HIGH;
 
     {
         olsr::MessageHeader::Hello::LinkMessage lm1;
@@ -214,7 +215,7 @@
     olsr::MessageHeader::Hello& helloOut = msgOut.GetHello();
 
     NS_TEST_ASSERT_MSG_EQ(helloOut.GetHTime(), Seconds(7), "300");
-    NS_TEST_ASSERT_MSG_EQ(helloOut.willingness, 66, "301");
+    NS_TEST_ASSERT_MSG_EQ(helloOut.willingness, olsr::Willingness::HIGH, "301");
     NS_TEST_ASSERT_MSG_EQ(helloOut.linkMessages.size(), 2, "302");
 
     NS_TEST_ASSERT_MSG_EQ(helloOut.linkMessages[0].linkCode, 2, "303");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/olsr/test/olsr-routing-protocol-test-suite.cc ns-3.39/src/olsr/test/olsr-routing-protocol-test-suite.cc
--- ns-3.38/src/olsr/test/olsr-routing-protocol-test-suite.cc	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/olsr/test/olsr-routing-protocol-test-suite.cc	2023-07-05 14:23:48.069428200 -0700
@@ -20,6 +20,7 @@
  */
 
 #include "ns3/ipv4-header.h"
+#include "ns3/olsr-repositories.h"
 #include "ns3/olsr-routing-protocol.h"
 #include "ns3/test.h"
 
@@ -28,19 +29,6 @@
  * \defgroup olsr-test olsr module tests
  */
 
-/********** Willingness **********/
-
-/// Willingness for forwarding packets from other nodes: never.
-#define OLSR_WILL_NEVER 0
-/// Willingness for forwarding packets from other nodes: low.
-#define OLSR_WILL_LOW 1
-/// Willingness for forwarding packets from other nodes: medium.
-#define OLSR_WILL_DEFAULT 3
-/// Willingness for forwarding packets from other nodes: high.
-#define OLSR_WILL_HIGH 6
-/// Willingness for forwarding packets from other nodes: always.
-#define OLSR_WILL_ALWAYS 7
-
 using namespace ns3;
 using namespace olsr;
 
@@ -83,7 +71,7 @@
      */
     NeighborTuple neighbor;
     neighbor.status = NeighborTuple::STATUS_SYM;
-    neighbor.willingness = OLSR_WILL_DEFAULT;
+    neighbor.willingness = Willingness::DEFAULT;
     neighbor.neighborMainAddr = Ipv4Address("10.0.0.2");
     protocol->m_state.InsertNeighborTuple(neighbor);
     neighbor.neighborMainAddr = Ipv4Address("10.0.0.3");
@@ -139,7 +127,7 @@
                           true,
                           "Node 1 must select node 3 as MPR");
     /*
-     *  7 (OLSR_WILL_ALWAYS)
+     *  7 (Willingness::ALWAYS)
      *  |
      *  1 -- 2 -- 5
      *  |    |
@@ -147,9 +135,9 @@
      *  |
      *  6
      *
-     * Node 1 must select nodes 2, 3 and 7 (since it is WILL_ALWAYS) as MPRs.
+     * Node 1 must select nodes 2, 3 and 7 (since it is Willingness::ALWAYS) as MPRs.
      */
-    neighbor.willingness = OLSR_WILL_ALWAYS;
+    neighbor.willingness = olsr::Willingness::ALWAYS;
     neighbor.neighborMainAddr = Ipv4Address("10.0.0.7");
     protocol->m_state.InsertNeighborTuple(neighbor);
 
@@ -160,18 +148,18 @@
                           true,
                           "Node 1 must select node 7 as MPR");
     /*
-     *                7 <- WILL_ALWAYS
-     *                |
-     *      9 -- 8 -- 1 -- 2 -- 5
-     *                |    |
-     *           ^    3 -- 4
-     *           |    |
-     *   WILL_NEVER   6
+     *                        7 <- Willingness::ALWAYS
+     *                        |
+     *              9 -- 8 -- 1 -- 2 -- 5
+     *                        |    |
+     *                   ^    3 -- 4
+     *                   |    |
+     *   Willingness::NEVER   6
      *
-     * Node 1 must select nodes 2, 3 and 7 (since it is WILL_ALWAYS) as MPRs.
-     * Node 1 must NOT select node 8 as MPR since it is WILL_NEVER
+     * Node 1 must select nodes 2, 3 and 7 (since it is Willingness::ALWAYS) as MPRs.
+     * Node 1 must NOT select node 8 as MPR since it is Willingness::NEVER
      */
-    neighbor.willingness = OLSR_WILL_NEVER;
+    neighbor.willingness = Willingness::NEVER;
     neighbor.neighborMainAddr = Ipv4Address("10.0.0.8");
     protocol->m_state.InsertNeighborTuple(neighbor);
     tuple.neighborMainAddr = Ipv4Address("10.0.0.8");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/openflow/examples/openflow-switch.cc ns-3.39/src/openflow/examples/openflow-switch.cc
--- ns-3.38/src/openflow/examples/openflow-switch.cc	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/openflow/examples/openflow-switch.cc	2023-07-05 14:23:48.069428200 -0700
@@ -1,4 +1,5 @@
 /*
+ *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation;
@@ -11,6 +12,9 @@
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Blake Hurd <naimorai@gmail.com>
+ * Modified by: Josh Pelkey <joshpelkey@gmail.com>
  */
 
 // Network topology
